/* $Id: ftok.c,v 1.4 2002/11/12 19:14:06 cwilson Exp $ */

#include <sys/ipc.h>
#if defined OLDCYGIPC

/* Copyright (C) 1995, 1996 Free Software Foundation, Inc.
   This file is part of the GNU C Library.
   Contributed by Ulrich Drepper <drepper@gnu.ai.mit.edu>, August 1995.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#include <sys/ipc.h>
#include <sys/stat.h>

key_t
ftok (const char *path, int id)
{
  struct stat st;
  key_t key;

  if (stat (path, &st) < 0)
    return (key_t) -1;

  key = ((st.st_ino & 0xffff) | ((st.st_dev & 0xff) << 16)
	 | ((id & 0xff) << 24));

  return key;
}

#else /* OLDCYGIPC */

/* Copyright (C) 2001 Red Hat, Inc.

   Originally written by Robert Collins <robert.collins@hotmail.com>

   This file is part Cygwin

   This software is a copyrighted work licensed under the terms of
	the Cygwin license.  Please consult the file "CYGWIN_LICENSE" for
	details.
*/

#include <sys/ipc.h>
#include <sys/stat.h>

/* Notes: we return a valid key even if id's low order 8 bits are 0. */
key_t
ftok(const char *path, int id)
{
  struct stat statbuf;
  if (stat(path, &statbuf))
    {
      /* stat set the appropriate errno for us */
      return (key_t) -1;
    }
  
  /* dev_t is short for cygwin 
   * ino_t is long for cygwin
   * and we need 8 bits for the id.
   * thus key_t is long long. 
   */
  return ((long long) statbuf.st_dev << (5*8)) | (statbuf.st_ino << (8) ) | (id & 0x00ff);
}
#endif /* OLDCYGIPC */
